% Matlab Programm fuer 1D- Problem
% -au''+bu'+cu=f in (0,1)
% a,b,c konstant

clear all;
close all;

% Netz laden
load coordinates.dat
load elements.dat
load dirichlet.dat

teil = 'b';

switch teil
  case 'a'
    a=1;b=0;c=0;     u_d=[0;0]; f = @(x) 1; u_exact = @(x) 1/2*(-x^2+x);
  case 'b'
    a=1;b=0;c=0;     u_d=[0;1]; f = @(x) 1; u_exact = @(x) -1/2*x^2+3/2*x;
  case 'c'
    a=1;b=0;c=0;     u_d=[0;0]; f = @(x) x; u_exact = @(x) 1/6*x*(-x^2+1);
  case 'd'
    a=1;b=0;c=1/100; u_d=[0;0]; f = @(x) 1; u_exact = @(x) -100*(exp(-x/10+1/10)-exp(1/10)+exp(x/10)-1)/(1+exp(1/10)); 
  case 'e'
    a=1;b=1/10;c=0;  u_d=[0;0]; f = @(x) 1; u_exact = @(x) 10*(-exp(x/10)+x*exp(1/10)-x+1)/(exp(1/10)-1);
  case 'f'
    a=1;b=0;c=100;   u_d=[0;0]; f = @(x) 1; u_exact = @(x) -0.01*(exp(-10*x+10)-exp(10)+exp(10*x)-1)/(1+exp(10));
end


% Exakte Loesung plotten
fplot(u_exact,[0,1],'r--'),hold on

% berechne FEM
for k=1:3
  % Assembliere und loese LGS
  % TO DO: Loese LGS
  
  % FEM Loesung plotten
  plot(coordinates(elements)',u(elements)','k-');
  hold on;
  pause;
  
  % Verfeinere Gitter
  % TO DO: Verfeinere Gitter
end

% berechne letztes Mal FEM
% TO DO: Loese LGS

% Plot of the FE-solution
plot(coordinates(elements)',u(elements)','k-'),hold on
